package physbeans.inout;

import java.awt.*;
import javax.swing.*;
import java.io.*;
import physbeans.inout.PhysicsPanel;

/**
 * panel that displays "physical objects"
 */
public class ObjectPanel extends PhysicsPanel implements Serializable {
  Color bgColor = new Color(255, 255, 175); // light yellow

  /**
   * makes a new ObjectPanel.<br>
   * uses simple OverlayLayout<br>
   * sets standard colors
   */
  public ObjectPanel() {
    super();
    setLayout(new BorderLayout());
    setBackground(bgColor);
    setForeground(Color.black);
    setOpaque(true);  // sets color for its components
    setBorder(BorderFactory.createEmptyBorder(3,3,3,3));
  }
}
