package physbeans.views;

/**
 * HeatColorTable runs from blue (cold) to red (hot).
 */
public class HeatColorTable extends ColorTable {
  
  protected void defineRGBAValues() {
    for (int i=0; i<256; i++) {
      r[i] = (byte) i;
      g[i] = (byte) 0;
      b[i] = (byte) (255 - i);
    }
  }
}
